

/**
 * Class BlockInputStream is used to implement the block access the
 * data on disk. The instances of this class are constructed with
 * two arguments, disk file name and buffer size.
 *
 * From the IO test results, the buffer size should be between 16K
 * and 64K, which gives a good tradeoff between performance and space.
 *
 * @author Biao Hao (bhao@cs.mcgill.ca)
 * @version 0.5, 07/04/1997
 */
import java.io.*;

public class BlockInputStream extends DataInputStream
implements TypeConstants
{


   public BlockInputStream(String filename, int buffersize)
   throws IOException, FileNotFoundException
   {
	  super(new BufferedInputStream(
		 new FileInputStream(filename), buffersize));
   }      
   public BlockInputStream(DataInputStream DIS)
   {
  	super(DIS);
   }

   // Weizhong
   public String readString(String s)
   throws IOException
   {
	if (s.compareTo("^B") == 0) {
		return (STRING_DK);
	} else if (s.compareTo("^E") == 0) {
		return (STRING_DC);
	}
	return s;
   /* 	cancelled by Weizhong
   // Our string is stored as : short + byte array
   // Note there is shift of short value for the length of
   // string, so that the maximum length of string is
   // 2*Short.MAX_VALUE - 1 = 64*1024 - 3
	  int len = super.readShort() + Short.MAX_VALUE - 1;

	  if (len == -2) return STRING_DK;
	  else if (len == -1) return STRING_DC;
	  else if (len == 0) return new String("");
	  else {
		 byte[] b = new byte[len];
		 super.readFully(b);
		 return new String(b);
	  }
   */
   }

   public String readText(String s)
   throws IOException
   {
	if (s.compareTo("^B") == 0)
		return (STRING_DK);
	else if (s.compareTo("^E") == 0)
		return (STRING_DC);
	return s;
   /* cancelled by Weizhong
	// Our text is stored as : int + byte array
	// Note there is no shift for text length, so that the maximum
	// text length is Integer.MAX_VALUE
	  int len = super.readInt();

	  if (len == -2) return STRING_DK;
	  else if (len == -1) return STRING_DC;
	  else if (len == 0) return new String("");
	  else {
		 byte[] b = new byte[len];
		 super.readFully(b);
		 return new String(b);
	  }
   */
   }      
}
