
/**
*Class GeditColorEdit.
*
* The dialog of Color Editor which allows the user to edit the color of a
* uniform layer.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditColorEdit extends JDialog implements ActionListener{
  //graphic objects
  private JLabel activelayer;
  private JColorChooser tcc=null;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");

  private boolean ok;
  private Legend[] lgdarray;
  private String actlayer=null;
  private Hashtable lgdhtb;
  private int cursymbv=0;
  public GeditColorEdit(JFrame parent, String[] allayers,Hashtable legendhtb)
  {
    super(parent, "Color Editor",true);
    ok=false;
    lgdhtb=legendhtb;
    int colorv=0;
    int symbolv=0;

    //get the current active layer, color value, symbol value from the legend
    //hashtable
    if(lgdhtb!=null)
    for(int i=0;i<allayers.length;i++)
    {
     GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(allayers[i]);
     if(legendarray[0].getActive())
      {actlayer=legendarray[0].name;
      colorv=legendarray[0].color;
      symbolv=legendarray[0].symbol;
      }
     }

   if(actlayer!=null)
   {
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);

    //set up color chooser for setting text color
    Color curcolor=new Color(colorv/1000000, (colorv%1000000)/1000,colorv%1000);
    tcc=new JColorChooser(curcolor);
    JPanel buttonp=new JPanel();
    okbutton.addActionListener(this);
    buttonp.add(okbutton);
    cancelbutton.addActionListener(this);
    buttonp.add(cancelbutton);
    JPanel p=new JPanel();

    p.setLayout(new BorderLayout());
    p.add("North",activelayer);
    p.add("Center",tcc);
    p.add("South",buttonp);

   Border etched = BorderFactory.createEtchedBorder();
   p.setBorder(BorderFactory.createTitledBorder(etched,"Color Editor"));

    Container contentpane=getContentPane();
    contentpane.add("Center",p);

     Dimension d=parent.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;
     setSize(wid,hgt);
   }//end of if(actlayer!=null)
    }

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed

public boolean showDialog( Geditor geditor)
{  ok=false;
   if(actlayer==null)
   GeditGlobal.showErrorDialog((JFrame)geditor, "No active Layer.");
   else
     show();
     if(ok)
     {
     //get the new color value from the tcc
     Color newcolor=tcc.getColor();
     int colorvalue=GeditColor.color2int(newcolor);
     //update the mapview and legend hashtable with the new color value
     updMapColor(geditor,colorvalue);
     updLegend(geditor,colorvalue);
     }
      return(ok);
}
//update the color of the current active layer with the newvalue
private void updMapColor(Geditor gdt,int newvalue)
{
  cursymbv=0;
   Relation  rl=gdt.maprel;
   for(int i=0;i<rl.numtuples;i++)
    { if(((String[])rl.data[gdt.pL])[i].compareTo(actlayer)==0)
      {
       if(cursymbv==0) cursymbv=((int[])rl.data[gdt.pSymb])[i];//keep the same
       //symbol in the layer to make a uniform layer
       ((int[])rl.data[gdt.pC])[i]=newvalue;
       }
    }
    try{
    rl.save();
    //rl.unload();
    }catch(InterpretError ie){System.out.println("InterpretError");}
}

//update the legend hashtable with the new colorvalue
private void updLegend(Geditor geditor, int colorvalue)
{ GeditLegend[] lgdarray=(GeditLegend[])geditor.legendhtb.get(actlayer);
  GeditLegend[] newlgdarray=new GeditLegend[1];
  newlgdarray[0]=new GeditLegend(actlayer,actlayer,colorvalue,cursymbv,null,null,true,true,lgdarray[0].type);
  geditor.legendhtb.remove(actlayer);
  geditor.legendhtb.put(actlayer,newlgdarray);
}
}//end of ColorDialog 
