
/**
*Class GeditColorPatch.
*
* This class draws a color patch. When the user clicks mouse on the patch, a
* colorchooser will be popped out
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditColorPatch extends JPanel {
  Color selectedColor;
  private  Geditor geditor;

  public GeditColorPatch(Color color,Geditor gdt){
     setBorder(BorderFactory.createEtchedBorder());
     setBackground(color);

     geditor=gdt;
     addMouseListener(new MouseAdapter(){
       public void mousePressed(MouseEvent e){
//       selectedColor=JColorChooser.showDialog(GeditColorPatch.this, "Pick A Color",getBackground());
    JColorChooser tcc=new JColorChooser();
     JDialog colord=JColorChooser.createDialog(geditor,"Pick A Color",true,tcc,null,null);
     Dimension d=colord.getSize();
     colord.setSize(d.width+50,d.height+50);

     colord.show();
     selectedColor=tcc.getColor();

       if(selectedColor==null){
        //  JOptionPane.showMessageDialog(GeditColorPatch.this,"ColorChooser Canceled");
       }
       else{
          setBackground(selectedColor);
	  repaint();

	 }
      }
     });
    }
  public void setColor(Color color){
    setBackground(color);
    repaint();
    }

  public Color getColor(){
    return(getBackground());
    }
}
