
/**
*Class GeditExpression.
*
* The dialog of Expression Builder.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditExpression extends JDialog implements TypeConstants, ActionListener,ListSelectionListener{
  private JLabel activelayer;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JButton clearbutton=new JButton("Clear");
  //operator buttons
  private JButton andbutton=new JButton("and");
  private JButton orbutton=new JButton("or");
  private JButton greatbutton=new JButton(">");
  private JButton lessbutton=new JButton("<");
  private JButton greateqbutton=new JButton(">=");
  private JButton lesseqbutton=new JButton("<=");
  private JButton noteqbutton=new JButton("!=");
  private JButton leftbrbutton=new JButton("(");
  private JButton rightbrbutton=new JButton(")");
  private JButton eqbutton=new JButton("=");

  private DefaultListModel valuemodel=new DefaultListModel();
  private JList valuelist=new JList(valuemodel);
  private JList attrlist=null;

  private JLabel message;
  JTextField textarea=new JTextField("");

  private boolean ok;
  private Hashtable lgdhtb;
  private String actlayer=null;
  private Relation maprel;
  private int attrnum=0;
  public Geditor gdt;
  private int pos=-1;
  int selcolor=255255000;


  public GeditExpression(Geditor geditor, String[] allayers)
  {
    super((JFrame)geditor, "Expression Builder",true);
    Container contentpane=getContentPane();


    //initialize the attributes of this class
    gdt=geditor;
    maprel=geditor.maprel;
    lgdhtb=gdt.legendhtb;
    selcolor=gdt.selcolor;//get the selcolor from geditor
    ok=false;

    Domain[] doms=maprel.domains;
    int[] types=maprel.toTypes(maprel.domains);

    //get the active layer name
    if(lgdhtb!=null)
      actlayer=GeditGlobal.getActiveLayer(gdt);

   if(actlayer!=null)
   {
     
     //the activelayer label
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);


      //get the number of additional attributes(attributes except graphical
      //attrs)
     attrnum=0;
     for(int i=0;i<maprel.numattrs;i++)
     { 
     boolean t=GeditGlobal.isAddAttr(i,gdt); 
      if(GeditGlobal.isAddAttr(i,gdt))
        attrnum++;
     }

     //get the name of each additional attributes
      String[] attrname=new String[attrnum];
      int j=0;
      for(int i=0;i<doms.length;i++)
      {
        if(GeditGlobal.isAddAttr(i,gdt))
         {attrname[j]=doms[i].name;
          j++;
          }
       }

      if( attrnum==0)  message=new JLabel("There's no additional attributes");
       else message=new JLabel("Please select an attribute, an operator and a value from above lists");

     message.setForeground(gdt.messagecolor);

     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;

     attrlist=new JList(attrname);
     attrlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     attrlist.setFixedCellWidth(wid/5);
     attrlist.setFixedCellHeight(hgt/24);
     JScrollPane attrscp=new JScrollPane(attrlist);
     attrlist.addListSelectionListener(this);

     JPanel buttonp=new JPanel();
     GridBagLayout gb=new GridBagLayout();
     buttonp.setLayout(gb);
     GridBagConstraints con=new GridBagConstraints();
     con.fill=GridBagConstraints.BOTH;
     con.weightx=0;
     con.weighty=0;
     GeditGlobal.add(buttonp,clearbutton,con,0,0,1,1);
     GeditGlobal.add(buttonp,okbutton,con,0,1,1,1);
     GeditGlobal.add(buttonp,cancelbutton,con,0,2,1,1);
     okbutton.addActionListener(this);
     okbutton.setEnabled(false);//initially disable okbutton
     cancelbutton.addActionListener(this);
     clearbutton.addActionListener(this);

     //construct the operator panel
     JPanel operatorp=new JPanel();

     GridBagLayout gbl=new GridBagLayout();
     operatorp.setLayout(gbl);
     GridBagConstraints constr=new GridBagConstraints();

     constr.fill=GridBagConstraints.BOTH;
     constr.weightx=0;
     constr.weighty=0;
     GeditGlobal.add(operatorp,leftbrbutton,constr,0,0,1,1);
     GeditGlobal.add(operatorp,rightbrbutton,constr,1,0,1,1);
     GeditGlobal.add(operatorp,greatbutton,constr,0,1,1,1);
     GeditGlobal.add(operatorp,lessbutton,constr,1,1,1,1);
     GeditGlobal.add(operatorp,greateqbutton,constr,0,2,1,1);
     GeditGlobal.add(operatorp,lesseqbutton,constr,1,2,1,1);
     GeditGlobal.add(operatorp,eqbutton,constr,0,3,1,1);
     GeditGlobal.add(operatorp,noteqbutton,constr,1,3,1,1);
     GeditGlobal.add(operatorp,andbutton,constr,0,4,1,1);
     GeditGlobal.add(operatorp,orbutton,constr,1,4,1,1);

     greatbutton.addActionListener(this);
     greateqbutton.addActionListener(this);
     lessbutton.addActionListener(this);
     lesseqbutton.addActionListener(this);
     eqbutton.addActionListener(this);
     noteqbutton.addActionListener(this);
     andbutton.addActionListener(this);
     orbutton.addActionListener(this);
     leftbrbutton.addActionListener(this);
     rightbrbutton.addActionListener(this);


     
     valuelist.setFixedCellWidth(wid/5);
     valuelist.setFixedCellHeight(hgt/24);
     valuelist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     valuelist.addListSelectionListener(this);
     valuemodel.addElement("");
     JScrollPane valuescp=new JScrollPane(valuelist);

     //title of the lists
     JLabel t_attrs=new JLabel("Attributes ");
     JLabel t_operators=new JLabel("Operators");
     JLabel t_values=new JLabel("Values");


     textarea.setBorder(BorderFactory.createEtchedBorder());
     operatorp.setBorder(BorderFactory.createEtchedBorder());

     //construct the center panel
     JPanel centerp=new JPanel();
     GridBagLayout gbag=new GridBagLayout();
     centerp.setLayout(gbag);
     GridBagConstraints cons=new GridBagConstraints();
     cons.weightx=100;
     cons.weighty=0;
     cons.fill=GridBagConstraints.BOTH;
     GeditGlobal.add(centerp,activelayer,cons,0,0,3,1);

     GeditGlobal.add(centerp,t_attrs,cons,0,1,1,1);
     GeditGlobal.add(centerp,t_operators,cons,1,1,1,1);
     GeditGlobal.add(centerp,t_values,cons,2,1,1,1);

     cons.weightx=0;
     cons.weighty=100;
     GeditGlobal.add(centerp,attrscp,cons,0,2,1,3);

     GeditGlobal.add(centerp,operatorp,cons,1,2,1,3);

     GeditGlobal.add(centerp,valuescp,cons,2,2,1,3);

     cons.weightx=100;
     GeditGlobal.add(centerp,textarea,cons,0,5,2,1);
     GeditGlobal.add(centerp,buttonp,cons,2,5,1,1);
     
     cons.weighty=0;
     GeditGlobal.add(centerp,message,cons,0,6,3,1);


     Border etched = BorderFactory.createEtchedBorder();
     centerp.setBorder(BorderFactory.createTitledBorder(etched,"Expression Builder"));
     contentpane.add("Center",centerp);
     setSize(wid,hgt);
   }//end of if(actlayer!=null) 

}
 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
   String text=textarea.getText();
   if(source==andbutton)
    textarea.setText(text+" and ");
    else if(source==orbutton)
    textarea.setText(text+" or ");
    else if(source==greatbutton)
    textarea.setText(text+" > ");
    else if(source==lessbutton)
    textarea.setText(text+" < ");
    else if(source==eqbutton)
    textarea.setText(text+" = ");
    else if(source==lesseqbutton)
    textarea.setText(text+" <= ");
    else if(source==noteqbutton)
    textarea.setText(text+" != ");
    else if(source==greateqbutton)
    textarea.setText(text+" >= ");
    else if(source==leftbrbutton)
    textarea.setText(text+" ( ");
    else if(source==rightbrbutton)
    textarea.setText(text+" ) ");

    else if(source==okbutton)
    {ok=true;setVisible(false);}
    else if(source==cancelbutton)
    setVisible(false);
    else if(source==clearbutton)
    textarea.setText("");



  }

 public void valueChanged(ListSelectionEvent evt)
 {
  JList source=(JList)evt.getSource();
 if(source==attrlist)
 {
   okbutton.setEnabled(true);//activate okbutton 
   String attr=(String)source.getSelectedValue();
   if(attr!=null)
   {
   attr.trim();
   String text=textarea.getText();
   textarea.setText(text+attr);

   source.clearSelection();//clear the selection of attrlist 

   //add the values of the selected attr to valuelist
   if (valuemodel!=null)valuemodel.clear();
   Object[] values=getValues(attr);
   for(int i=0;i<values.length;i++)
   {if(values[i]!=null)
      valuemodel.addElement(values[i]);
   }
   }
  }
  else if(source==valuelist)
  {
   okbutton.setEnabled(true);//activate okbutton 
   String text=textarea.getText();
   Object Val=source.getSelectedValue();
   if(Val!=null)
   {
     String classname=Val.getClass().getName();
     //if the Val is String, add quotes
     if(classname.compareTo("java.lang.String")==0)
      textarea.setText(text+"\""+Val+"\"");
      else //not String
        textarea.setText(text+Val.toString());
      source.clearSelection();//clear the selection of valuelist
   }
  }
   
   
}

//getValues returns the values of the attr in maprel
private Object[] getValues(String attr)
{
      int pos=-1;
      Object[] values=new Object[gdt.maprel.numtuples];

      //find the position of this attr
      Domain[] doms=gdt.maprel.domains;
      for(int j=0;j<doms.length;j++)
      {
      if (attr.compareTo((doms[j].name).trim())==0)
       {pos=j; break;}
      }

      int pL=gdt.pL;

     if(pos!=-1)
     {
       int k=0;
      for(int i=0;i<gdt.maprel.numtuples;i++)
      {
          
	   String layer=((String[])gdt.maprel.data[pL])[i];
	   if(layer.compareTo(actlayer)==0)//get values only from active layer
	   {
           Object Val=GeditGlobal.calVal(gdt.maprel,i,pos);
           String val=Val.toString();
	   if(notInValues(val,values))//if this value has not appeared in
	   			      //values array, then add it 
	   {values[k]=Val;
	    k++;}
	   }
      }
      }
      else {System.out.println("attr not found");}//never happen
      return(values);
 }

//notInValues check if this value val has been recorded into values array
private boolean notInValues(String val,Object[] values)
{
  for(int i=0;i<values.length;i++)
  {
    if(values[i]!=null)
    {
     if(val.compareTo(values[i].toString())==0)
       return(false);
     }
  }
   return(true);
}

public boolean showDialog(  )
{  ok=false;
   if(actlayer==null)
    GeditGlobal.showErrorDialog((JFrame)gdt, "No active Layer.");
    else
     show();
     if(ok)
     {
      String expr=textarea.getText();
      String lname=gdt.Lname;//the attr name of Layers

      //construct the complete where clause and execute it in relix
      //note that this selection must be performed in current active layer
         String commd=gdt.SelRel+"<-where ("+expr+") and "+lname+"=\""+actlayer+"\" in "+gdt.GeditMap+";";
	 System.out.println("==>commd="+commd);
	 int returnval=-1;
	 try{
          returnval=gdt.inter.executeRelixCommand(commd);
	  }catch(Exception ie){System.out.println("Expression Error.");
	  GeditGlobal.showErrorDialog((JFrame)gdt, "Expression Error.");
	  return(false);
	  }
         if(returnval!=0)
	      {GeditGlobal.showErrorDialog((JFrame)gdt, "Expression Error.");
	       return(false);
	       }
	 try{
	  gdt.selrel=gdt.inter.getRelbyName(gdt.SelRel);
	 }catch(InterpretError ie){;
	 } catch(NullPointerException ne){;}
         if(gdt.selrel!=null)GeditGlobal.updMapColor(gdt,gdt.selrel,gdt.selcolor);
     }
      return(ok);
 }


}//end of GeditExpression
