
/**
 * This class contains global methods for Geditor
 *
 */

 import java.io.*;
 import java.awt.*;
 import javax.swing.*;
 import java.math.*;
 import java.util.*;
public class GeditGlobal implements TypeConstants{

//returns the object at the position: row i, column j of maprel
public static Object calVal(Relation maprel,int i,int j)
{

   int[] types=maprel.toTypes(maprel.domains);

	  Object Val=null;
	  switch(types[j])
	  {case INTEGER:
	      {int val=((int[])maprel.data[j])[i];
	       Val=new Integer(val);
	      break;}
	   case STRING:
	   case STMT:
	   case EXPR:
	   case TEXT:
	       {Val=((String[])maprel.data[j])[i];
	      break;}
	   case BOOLEAN:
              {byte val=((byte[])maprel.data[j])[i];
	       Val=new Byte(val);
	      break;}
	   case SHORT:
	      {short val=((short[])maprel.data[j])[i];
	       Val=new Short(val);
	      break;}
	   case LONG:
	   case IDLIST:
	   case COMP:
	      {long val=((long[])maprel.data[j])[i];
	       Val=new Long(val);
	      break;}
	   case FLOAT:
	      {float val=((float[])maprel.data[j])[i];
	       Val=new Float(val);
	      break;}
	   case DOUBLE:
	      {double val=((double[])maprel.data[j])[i];
	       Val=new Double(val);
	      break;}
	   }//end of switch
	   return(Val);
}//end of calVal()

//Coordinate calculate the logitude and latitude of point (iX,iY) according to
//factorX and factorY
public  static Point  Coordinate(Geditor gdt,int iX,int iY,double factorX,double factorY, int dX,int dY)
{
    
    int minX=gdt.minmax[0];
    int maxX=gdt.minmax[1];
    int minY=gdt.minmax[2];
    int maxY=gdt.minmax[3];

      int X=0,Y=0;
      //convert screen Longitude(iX)and latitude(iY) to screen pixcels X,Y
      if(factorX!=0)
       {
        if(iX>=0) X=(int)((double)dX-((double)iX-(double)minX)/factorX);
        else
	    X=(int)((double)dX-((double)maxX-(double)iX)/factorX);
       }
      else X=iX;
      if(factorY!=0)
       {
        if(iY>=0)
        Y=(int)((double)dY-((double)iY-(double)minY)/factorY);
        else Y=(int)((double)dY-((double)maxY-(double)iY)/factorY);
       }
      else 
        Y=iY;
Point p=new Point(X,Y);
return p;
}


//calculate the longitude and latitude of point(x,y)
//lonlat: 0---Longitude
//        1---Latitude
public  static double  LonLat(Geditor gdt,int P,int dX,int dY,int lonlat)
{
    //get minX,minY,maxX,maxY, factorX,factorY

    double val=0;
    int minX=gdt.minmax[0];
    int maxX=gdt.minmax[1];
    int minY=gdt.minmax[2];
    int maxY=gdt.minmax[3];

    double facX=((double)maxX-(double)minX)/(double)dX;
    double facY=((double)maxY-(double)minY)/(double)dY;
    double factorX,factorY;
    factorX=factorY=Math.max(facX,facY);



    //calculate the position of P in the Map coordinates 
    if(lonlat==0)//longitude
    {
    double ix_p=((dX-P)*factorX+minX);//positive x
    double ix_n=(maxX-(dX-P)*factorX);//negative x
    if(ix_p>=0) val=ix_p;
    else if(ix_n<0) val=ix_n;
      else System.out.println("coordinates x error:"+P);
    }
    else
    if(lonlat==1)//latitude
    {
     double iy_p=(dY-P)*factorY+minY;//positive y
     double iy_n=maxY-(dY-P)*factorY;//negative y
     if(iy_p>=0) val=iy_p;
     else if(iy_n<0) val=iy_n;
          else System.out.println("coordinates y error:"+P);
     }else
       System.out.println("parameter for XY error in LonLat()");
     return(val);
}//end of LonLat

//add method adds a component to JPanel p using GridBagLayout
public static void add(JPanel p,Component c, GridBagConstraints gbc,int x, int y, int w, int
h)
{ gbc.gridx = x;
  gbc.gridy = y;
  gbc.gridwidth =w;
  gbc.gridheight = h;
  p.add(c,gbc);
}

//isAddAttr check if the attribute is an additional attribute
//   true--additional attribute
//   false--not additional attribute

public static boolean isAddAttr(int pos,Geditor gdt){
for(int i=0;i<gdt.dom.length;i++)
{
if(gdt.maprel.domains[pos].name.compareTo(gdt.dom[i].name)==0)
  return(false);
}
   return(true);
  }

//update the activelayer map of Geditor
public static void updateActiveMap(Geditor gdt,String actname)
{
 String tmpstr=gdt.ActLRel+"<- where "+gdt.Lname+"=\""+actname+"\" in "+gdt.GeditMap+";";
 try{
  gdt.inter.executeRelixCommand(tmpstr);
  gdt.actlrel=gdt.inter.getRelbyName(gdt.ActLRel);
 }catch(InterpretError ie){System.out.println(ie.getMessage());}
}
//get a temporary name
public static String nextTempName(String prefix)
{
return(prefix+Math.abs(new Random().nextInt()));
}

//updMapColor change the color of selected groups in selmaprel(the relation showing temerory selections) to colorv. 
public static void updMapColor(Geditor gdt,Relation rel,int colorv)
{
  
  //keep SelMap in consistant with the current GeditMap
  //gdt.initSelMap();
  String[] groups={""};
  int pC=gdt.pC;
  int pG=gdt.pG;
  //extract the different grouops in rel 
  groups=extractGroups(pG,rel);

  Object[] data=gdt.selmaprel.data;
  for(int i=0;i<gdt.selmaprel.numtuples;i++)
  {
   String G=((String[])data[pG])[i];
   if(isSelected(G,groups))
   {
     ((int[])data[pC])[i]=colorv;
   }
  }
 try{  gdt.selmaprel.save();
 }catch(InterpretError ie){System.out.println(ie.getMessage());}
}

//extractGroups returns the groups in rel
private static String[] extractGroups(int pG,Relation rel)

{
   Object[] data=rel.data;
   String fG="";
   //calculate the number of groups in rel
   int k=0;
   for(int i=0;i<rel.numtuples;i++)
   {
    String G=((String[])data[pG])[i];
    if(G.compareTo(fG)!=0) k++;
   }
   String[] groups=new String[k];
   k=0;
   for(int i=0;i<rel.numtuples;i++)
    {
    String G=((String[])data[pG])[i];
    if(G.compareTo(fG)!=0)
    {groups[k]=G;k++;}
    }
    return(groups);
}

//check if the group G is in the selected groups: groups
private static  boolean isSelected(String G,String[]groups)
{
 for(int i=0;i<groups.length;i++)
 { if(G.compareTo(groups[i])==0)
   return(true);
 }
 return(false);
}

public static  void delRelation(Interpreter inter, String relname)
{
Relation rel=null;
try{
 rel=inter.env.lookupRel(relname,true);
}catch(InterpretError ie){System.out.println(ie.getMessage());}
if(rel!=null) inter.executeRelixCommand("dr " +relname+";");

}

//return the active layer name according to the current legend hashtable
public static String getActiveLayer(Geditor gdt)
{
  String actlayer=null;
   for(int i=0;i<gdt.allayers.length;i++)
    {
      GeditLegend[] legendarray=(GeditLegend[])gdt.legendhtb.get(gdt.allayers[i]);
      if(legendarray[0].getActive())
           actlayer=legendarray[0].name;
     }
     return(actlayer);

}

public static void showErrorDialog(JFrame parent, String message)
{
 JOptionPane pane=new JOptionPane(message,JOptionPane.ERROR_MESSAGE);
 JDialog errord=pane.createDialog(parent, null);
 Dimension d=errord.getSize();
 errord.setSize(d.width,d.height+10);
 errord.show();
}
}//end of GeditGlobal
