import java.io.*;
import java.math.*;
import javax.swing.*;
import java.awt.*;


public class GeditSpatial{

  public static String[] pointInPolygon(double px,double py,Geditor geditor)
  {
    Object[] data=geditor.maprel.data;
    int numtuples=geditor.maprel.numtuples;
    String fG="",G="";
    int numG=0;
    int pG=geditor.pG;
    int pT=geditor.pT;
    int pX=geditor.pX;
    int pY=geditor.pY;
    String T="";


    //get the number of polygon groups and the minx,miny and maxx, maxy of
    //each group
    for(int i=0;i<numtuples;i++)
    { 
       T=((String[])data[pT])[i];
       if(T.toUpperCase().compareTo("POLYGON")==0)
       {
           G=((String[])data[pG])[i];
           if(G.compareTo(fG)!=0)//new group
           {  numG++;
              fG=G;
            }
       }
    }
    
    //construct the array of Minimal Boundary Rectangle
    int[] minx=new int[numG];
    int[] maxx=new int[numG];
    int[] miny=new int[numG];
    int[] maxy=new int[numG];

    int mbrid=-1;
    for(int i=0;i<numtuples;i++)
    {
       T=((String[])data[pT])[i];
       if(T.toUpperCase().compareTo("POLYGON")==0)
       {
           G=((String[])data[pG])[i];
           int X=((int[])data[pX])[i];
           int Y=((int[])data[pY])[i];
           if(G.compareTo(fG)!=0)//new group
           { //init the array
	      mbrid++;
	      minx[mbrid]=X;
	      maxx[mbrid]=X;
	      miny[mbrid]=Y;
	      maxy[mbrid]=Y;
	   }
	   else //same group
	   { //update the array
	     if(X<minx[mbrid]) minx[mbrid]=X;
	     if(X>maxx[mbrid]) maxx[mbrid]=X;
	     if(Y<miny[mbrid]) miny[mbrid]=Y;
	     if(Y>maxy[mbrid]) maxy[mbrid]=Y;
	   }
	   fG=G;
       }
    }

    String[] selG=new String[numG];
    for(int i=0;i<selG.length;i++)//initialize selG
    {selG[i]="";}

    int X=0,Y=0,fX=0,fY=0,X1=0,Y1=0;
    int det=0;

    double sum=0;
    double twopie=6.28319;
    double pie=3.14159;
    double angle=0;

    G=fG="";
    boolean finish=true;//finish indicates the terminate the calculation of a
    			//polygon
    int k=0;
     mbrid=-1;
    for(int i=0;i<numtuples;i++)
    {
       T=((String[])data[pT])[i];
       G=((String[])data[pG])[i];
       if(G.compareTo(fG)!=0)//new group
       {  
         if(finish==false)
	   {
                  if(i!=0)//calculate the sum of the former group 
	         {
		  //calculate the last angle of former group
	          angle=Angle(X1,Y1,fX,fY,px,py);//X1,Y1 are the first point
		  				 //of the last group
	          sum=sum+angle;
	         if(Math.abs(Math.abs(sum)-twopie)<=0.03||Math.abs(Math.abs(sum)-pie)<=0.03)//found
	          {selG[k]=fG;k++;}

   	           sum=0;
		   finish=true;
		   }
           } 
           if(T.toUpperCase().compareTo("POLYGON")==0&&
	   inMBR(px,py,++mbrid,minx,maxx,miny,maxy))
           {
	       finish=false;//record X1,Y1 of theis group
               X1=X=((int[])data[pX])[i];
               Y1=Y=((int[])data[pY])[i];
	       fX=X;fY=Y;
	   }
	 }//end of new group
         else //same group
          {
           if(T.toUpperCase().compareTo("POLYGON")==0&&
	     inMBR(px,py,mbrid,minx,maxx,miny,maxy))
            {
              X=((int[])data[pX])[i];
               Y=((int[])data[pY])[i];
	       angle=Angle(X,Y,fX,fY,px,py);
	       //System.out.println("X="+X+" Y="+Y+ "fX="+fX+" fY="+fY);
	       //System.out.println("angle="+angle);
	       sum=sum+angle;
               fX=X;fY=Y;
	    }
          }//end of if polygon
     fG=G; 
    }//end of for
        //calculate the sum of the last group
	if(finish==false)
	{
	          angle=Angle(X1,Y1,fX,fY,px,py);
	          sum=sum+angle;
	         if(Math.abs(Math.abs(sum)-twopie)<=0.03||Math.abs(Math.abs(sum)-pie)<=0.03)//found
	          {selG[k]=fG;k++;}
   	           sum=0;
       }
	  return(selG);
  }

//inMBR checks if the point px,py is in the MBR[mbrid]
private static boolean inMBR(double px,double py,int mbrid,int[]minx,int[]maxx,int[]miny,int[]maxy)
{
if((px<=maxx[mbrid])&&(px>=minx[mbrid])&&(py<=maxy[mbrid])&&(py>=miny[mbrid]))
 return(true);
 else return(false);
}
private static double Angle(int X, int Y, int fX,int fY,double px,double py)
{
        double det=px*fY*1+fX*Y*1+X*py*1-px*1*Y-fX*py*1-fY*1*X;
	int sign=0;
	if(det<0) sign=-1;
	else if(det>0) sign=1;
	     else sign=0;
	     //System.out.println("sign="+sign);
	double a2=Math.pow((px-fX),2)+Math.pow((py-fY),2);
	double b2=Math.pow(px-X,2)+Math.pow(py-Y,2);
	double c2=Math.pow(X-fX,2)+Math.pow(Y-fY,2);
	double val=((a2+b2-c2)/(2*Math.sqrt(a2)*Math.sqrt(b2)));
	//System.out.print("val is"+val);
	if((1.0000001-val)<0.0000001) val=1.0;
	double angle=(Math.acos(val))*sign;
	//System.out.println("   angle in Angle is"+angle);
	return(angle);
}

  //pointOnLine checks if there's any line in maprel of geditor such that
  //the point (px,py) is on this line
  public static String[] pointOnLine(double px,double py,Geditor geditor)
  {
    Object[] data=geditor.maprel.data;
    int numtuples=geditor.maprel.numtuples;
    String fG="",G="";
    int numG=0;
    int pG=geditor.pG;
    int pT=geditor.pT;
    String T="";

    for(int i=0;i<numtuples;i++)
    { 
       T=((String[])data[pT])[i];
       if(T.toUpperCase().compareTo("POLYLINE")==0)
       {
           G=((String[])data[pG])[i];
           if(G.compareTo(fG)!=0)//new group
           {  numG++;
              fG=G;
            }
       }
    }

    String[] selG=new String[numG];
    for(int i=0;i<selG.length;i++)//initialize selG
    {selG[i]="";}

    int pX=geditor.pX;
    int pY=geditor.pY;
    double X=0,Y=0,fX=0,fY=0;


    G=fG="";int k=0;
    for(int i=0;i<numtuples;i++)
    {
       T=((String[])data[pT])[i];
       if(T.toUpperCase().compareTo("POLYLINE")==0)
       {
           G=((String[])data[pG])[i];
           X=(double)((int[])data[pX])[i];
           Y=(double)((int[])data[pY])[i];
           if(G.compareTo(fG)==0)//same group
            {
	     if(X==px&&Y==py||px==fX&&py==fY)
	      { System.out.println("on vertex");
	        if(k!=0) 
	        if(selG[k-1].compareTo(G)!=0)
		{System.out.println("add to selG"); selG[k]=G;k++;}
  	      }
	     else 
	     if((X<=px&&px<=fX||fX<=px&&px<=X)&&(Y<=py&&py<=fY||fY<=py&&py<=Y))
	     {
             double det=px*fY*1+fX*Y*1+X*py*1-px*1*Y-fX*py*1-fY*1*X;
	     double dist=Math.sqrt((X-fX)*(X-fX)+(Y-fY)*(Y-fY));
	     double rate=det/dist;
	     if(Math.abs(rate)<3)//theoretically det should be 0, estimation
	     {
	     selG[k]=G;k++;}
	     }
           }//end of same group
           fX=X;fY=Y;fG=G;
        }//end of if polyline
    }//end of for
	  return(selG);
  }
}

