
/**
*Class GeditSpatialQuery.
*
* The dialog of Spatial Query.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditSpatialQ extends JDialog implements TypeConstants, ActionListener,ListSelectionListener{
  private JLabel activelayer;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JTextField value;
  private JLabel valuetitle;
  private int textlen=6;
  private Color oldcolor;


  // spatial operator list
  private JList operatorlist=null;

  private JLabel message;
  JTextField textarea=new JTextField("");

  private boolean ok;
  private Hashtable lgdhtb;
  private String actlayer=null;
  private Relation maprel;
  private int attrnum=0;
  public Geditor gdt;
  private int pos=-1;


  public GeditSpatialQ(Geditor geditor, String[] allayers)
  {
    super((JFrame)geditor, "Expression Builder",true);
    Container contentpane=getContentPane();

     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;

    //initialize the attributes of this class
    gdt=geditor;
    maprel=geditor.maprel;
    lgdhtb=gdt.legendhtb;
    ok=false;

    Domain[] doms=maprel.domains;
    int[] types=maprel.toTypes(maprel.domains);

    //get the active layer name
    if(lgdhtb!=null)
     actlayer=GeditGlobal.getActiveLayer(gdt);

   if(actlayer!=null)
   {

    //the activelayer label
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);

    //construct the value textfiled
    valuetitle=new JLabel("Value:");
    valuetitle.setForeground(Color.gray);
    value=new JTextField(textlen);
    value.setEnabled(false);

     //construct the operator list
      String[] oprname={"Completely Contain","Completely Within","Contain","Within","Intersect","Within Distance Of"};


     operatorlist=new JList(oprname);
     operatorlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     operatorlist.setFixedCellWidth(wid/5);
     operatorlist.setFixedCellHeight(hgt/12);
     JScrollPane oprscp=new JScrollPane(operatorlist);
     operatorlist.addListSelectionListener(this);

     //construct button panel
     JPanel buttonp=new JPanel();
     buttonp.add(okbutton);
     buttonp.add(cancelbutton);
     okbutton.addActionListener(this);
     okbutton.setEnabled(false);//initially disable okbutton
     cancelbutton.addActionListener(this);

     //title of the lists
     JLabel t_spopr=new JLabel("Spatial Operators ");

     message=new JLabel("Please select an operator from above list");
     message.setForeground(gdt.messagecolor);


     //construct the center panel
     JPanel centerp=new JPanel();
     GridBagLayout gbag=new GridBagLayout();
     centerp.setLayout(gbag);
     GridBagConstraints cons=new GridBagConstraints();
     cons.weightx=0;
     cons.weighty=0;
     cons.ipady=20;
     cons.fill=GridBagConstraints.BOTH;
     GeditGlobal.add(centerp,activelayer,cons,0,0,1,1);

     cons.ipady=0;
     GeditGlobal.add(centerp,t_spopr,cons,0,1,1,1);

     cons.weighty=100;
     GeditGlobal.add(centerp,oprscp,cons,0,2,1,3);

     cons.weighty=0;
     GeditGlobal.add(centerp,valuetitle,cons,1,2,1,1);
     GeditGlobal.add(centerp,value,cons,1,3,1,1);
     cons.ipady=10;
     GeditGlobal.add(centerp,buttonp,cons,0,5,1,1);
     
     GeditGlobal.add(centerp,message,cons,0,6,1,1);


     Border etched = BorderFactory.createEtchedBorder();
     centerp.setBorder(BorderFactory.createTitledBorder(etched,"Spatial Query"));
     contentpane.add("Center",centerp);
     setSize(wid,hgt);
   }//end of if(actlayer!=null)

}
 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
   String text=textarea.getText();
    if(source==okbutton)
    {ok=true;setVisible(false);}
    else if(source==cancelbutton)
    setVisible(false);


  }

 public void valueChanged(ListSelectionEvent evt)
 {
  JList source=(JList)evt.getSource();
 if(source==operatorlist)
 {
   okbutton.setEnabled(true);//activate okbutton 
      String opr=(String)operatorlist.getSelectedValue();
      if(opr.compareTo("Within Distance Of")==0)
      {
      value.setEnabled(true);
      oldcolor=valuetitle.getForeground();
      valuetitle.setForeground(Color.black);
      }
      else
      {
      value.setEnabled(false);
      valuetitle.setForeground(new Color(177,177,177));//turn gray
      }
   }
}


public boolean showDialog(  )
{  ok=false;
   if(actlayer==null)
   GeditGlobal.showErrorDialog((JFrame)gdt,"No active Layer.");
    else
     show();
     if(ok)
     {
      if(gdt.inter.env.reltable.getRel(gdt.SelRel)==null)
      {
   GeditGlobal.showErrorDialog((JFrame)gdt,
   "Please first select map feature(s) using Expression Builder.");
      ok=false;
      }
      else
      {
        String opr=(String)operatorlist.getSelectedValue();
      //String prefix="post";
      //get the event name
      String EventName="";
      if(opr!=null)
      {
         if(opr.compareTo("Completely Contain")==0)
           EventName="cmpcontains";
          else if(opr.compareTo("Completely Within")==0)
          EventName="cmpwithin";
          else if(opr.compareTo("Contain")==0)
          EventName="contains";
          else if(opr.compareTo("Within")==0)
          EventName="within";
	  else if(opr.compareTo("Intersect")==0)
	  EventName="intersect";
          else if(opr.compareTo("Within Distance Of")==0)
	  {
          EventName="withindist";
	  //construct the ValueRel
	  String valuestr="";
	  try{
	    valuestr=value.getText();
	  }catch(NullPointerException ne){
	    GeditGlobal.showErrorDialog((JFrame)gdt,
	    "Please enter the value in the Value field.");
	    ok=false;
	    return(ok);
	  }
	  if(valuestr.compareTo("")!=0)
	  {
	  double Value=new Double(valuestr).doubleValue();
	  String commd="domain V double;";
	  try{
	  gdt.inter.executeRelixCommand(commd);
	   commd="relation "+gdt.ValueRel+"(V)<-{("+Value+")};";
	   //System.out.println("==>commd="+commd);
	  gdt.inter.executeRelixCommand(commd);
	  }catch(Error ie){System.out.println(ie.getMessage());
	  GeditGlobal.showErrorDialog((JFrame)gdt,"Value error");
	  }
	  }
	  else return(false);
	  }
      }
      //invoke event handler
      if(EventName.compareTo("")!=0)
       try{
        boolean exist=gdt.inter.executeEventH(EventName,gdt.inter.env);
	if(exist==false)
	   {
	    GeditGlobal.showErrorDialog((JFrame)gdt,
	    "Ask Aldat Programmer to build the event handler first.");
	    ok=false;
	    }
	 else
	 {
	gdt.spqrel=gdt.inter.getRelbyName(gdt.SpqRel);
        if(gdt.spqrel!=null)
	   GeditGlobal.updMapColor(gdt,gdt.spqrel,gdt.spqcolor);
	  }
	}catch(InterpretError ie){System.out.println(ie.getMessage());}
     }
     }
      return(ok);
 }



}//end of GeditSpatialQ
