
/**
*Class GeditSymbolEdit.
*
* The dialog of Symbol Editor.
* The Symbol Editor is enabled only when the current active layer type is
* point. 
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class GeditSymbolEdit extends JDialog implements ActionListener{
//Graphic objects
  private JLabel activelayer;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JButton ovb;
  private JButton cir2b;
  private JButton starb;
  private JButton trib;
  private JButton trib2;
  private JButton cirb;
  private JButton flagb;
  private GeditSymbolIcon selsymbol;

  private JPanel leftp;
  private int pwid=0;
  private int phgt=0;
  private int width=0;
  private boolean ok;
  private GeditLegend[] lgdarray;
  private String actlayer=null;
  private Hashtable lgdhtb;
  private int curcolorv=0;//the color value of the active layer
                          //must be one to keep the active layer a uniform
			  //layer
  public GeditSymbolEdit(JFrame parent, String[] allayers,Hashtable legendhtb)
  {
    super(parent, "Layer Control",true);

     Dimension d=parent.getSize();
     int dX=d.width;
     int dY=d.width;
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt/3;
     setSize(wid,hgt);

    ok=false;
    lgdhtb=legendhtb;
    //int colorv=0;
    int symbolv=0;
    if(lgdhtb!=null)
    for(int i=0;i<allayers.length;i++)
    {
     GeditLegend[] legendarray=(GeditLegend[])lgdhtb.get(allayers[i]);
     if(legendarray==null) System.out.println("legendarray is null");
     if(legendarray[0].getActive())
      {actlayer=legendarray[0].name;
      //colorv=legendarray[0].color;
      symbolv=legendarray[0].symbol;
      }
     }
    if(actlayer!=null)
    {
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);


     leftp=new JPanel();
     GridBagLayout gbl=new GridBagLayout();
     leftp.setLayout(gbl);
     GridBagConstraints constraints=new GridBagConstraints();
     constraints.weightx=0;
     constraints.weighty=0;
     constraints.ipadx=0;
     constraints.ipady=0;
     constraints.fill=GridBagConstraints.BOTH;
     JLabel curlabel=new JLabel("Current Symbol:");
     GeditGlobal.add(leftp,curlabel,constraints,0,0,1,1);

     //width=wid/40; 
     width=wid/30; 
     pwid=width*3;
     //phgt=(pwid*2)/3;
     phgt=(pwid*3)/4;
     GeditSymbolIcon cursymbol=new GeditSymbolIcon(symbolv,width,pwid,phgt);
     cursymbol.setBorder(BorderFactory.createEtchedBorder()); 
     constraints.ipadx=40;
     constraints.ipady=40;
     GeditGlobal.add(leftp,cursymbol,constraints,1,0,2,2);

     JLabel selable=new JLabel("Selected Symbol:");
     constraints.ipadx=0;
     constraints.ipady=0;
     GeditGlobal.add(leftp,selable,constraints,0,2,1,1);


     selsymbol=new GeditSymbolIcon(symbolv,width,pwid,phgt);
     selsymbol.setBorder(BorderFactory.createEtchedBorder()); 
     constraints.ipadx=40;
     constraints.ipady=40;
     GeditGlobal.add(leftp,selsymbol,constraints,1,2,2,2);


     OvalIcon ov=new OvalIcon(width,width,dX,dY);
      ovb=new JButton(ov);
     ovb.addActionListener(this);

     Circle2Icon cir2=new Circle2Icon(width,width,dX,dY);
      cir2b=new JButton(cir2);
     cir2b.addActionListener(this);

     TriangleIcon tri=new TriangleIcon(width,width,dX,dY);
     trib=new JButton(tri);
     trib.addActionListener(this);

     HolTriangleIcon tri2=new HolTriangleIcon(width,width,dX,dY);
     trib2=new JButton(tri2);
     trib2.addActionListener(this);

     CircleIcon cir=new CircleIcon(width,width,dX,dY);
     cirb=new JButton(cir);
     cirb.addActionListener(this);

     FlagIcon flag=new FlagIcon(width,width,dX,dY);
     flagb=new JButton(flag);
     flagb.addActionListener(this);

     //BlankIcon blk=new BlankIcon(); 
     //JButton b7=new JButton(blk);
     JButton b7=new JButton();

     //JButton b8=new JButton(blk);
     JButton b8=new JButton();
     //b8.setMinimumSize(butsize);

    // JButton b9=new JButton(blk);
     JButton b9=new JButton();
     //b9.setMinimumSize(butsize);

     JPanel rightp=new JPanel();

     GridBagLayout gridbag=new GridBagLayout();
     GridBagConstraints cons=new GridBagConstraints();
     rightp.setLayout(gridbag);
     cons.weightx=0;
     cons.weighty=0;
     cons.gridwidth=1;
     cons.gridheight=1;
     cons.ipady=20;
     cons.fill=GridBagConstraints.BOTH;
     GeditGlobal.add(rightp,ovb,cons,0,0,1,1);

     GeditGlobal.add(rightp,cir2b,cons,1,0,1,1);

     GeditGlobal.add(rightp,cirb,cons,2,0,1,1);

     GeditGlobal.add(rightp,trib,cons,0,1,1,1);

     GeditGlobal.add(rightp,trib2,cons,1,1,1,1);

     GeditGlobal.add(rightp,flagb,cons,2,1,1,1);

     rightp.setBorder(BorderFactory.createLineBorder(Color.blue));


    JPanel buttonp=new JPanel();
     okbutton.addActionListener(this);
    buttonp.add(okbutton);
     cancelbutton.addActionListener(this);
    buttonp.add(cancelbutton);

    JLabel symbsel=new JLabel("Symbol lists:");

    JPanel p=new JPanel();
    GridBagLayout gridbl=new GridBagLayout();
    p.setLayout(gridbl);
     GridBagConstraints c=new GridBagConstraints();
    c.weightx=0;
    c.weighty=0;
    c.anchor=GridBagConstraints.WEST;
    GeditGlobal.add(p,activelayer,c,0,0,1,1);

    c.anchor=GridBagConstraints.CENTER;
    GeditGlobal.add(p,symbsel,c,1,1,1,1);

    c.ipady=40;
    c.ipadx=60;
    GeditGlobal.add(p,leftp,c,0,2,1,1);

    c.ipady=50;
    c.ipadx=60;
    GeditGlobal.add(p,rightp,c,1,2,1,1);

    c.ipady=0;
    c.ipadx=60;
    c.insets=new Insets(20,0,0,0);
    GeditGlobal.add(p,buttonp,c,0,3,2,1);

  Border etched = BorderFactory.createEtchedBorder();
  p.setBorder(BorderFactory.createTitledBorder(etched,"Symbol Editor"));

    Container contentpane=getContentPane();
    contentpane.add("Center",p);
    }//end of if(actlayer!=null)

 }//end of constructor

 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==ovb)
     {
      selsymbol.setSymb(201);
      selsymbol.repaint();
      selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
      }
      else if(source==cir2b)
      {
       selsymbol.setSymb(202);
       selsymbol.repaint();
       selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
      } 
      else if(source==cirb)
      {
       selsymbol.setSymb(203);
       selsymbol.repaint();
       selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
       }
       else if(source==trib)
      {
       selsymbol.setSymb(204);
       selsymbol.repaint();
       selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
       }
       else if(source==trib2)
       {
       selsymbol.setSymb(205);
       selsymbol.repaint();
       selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
      }
      else if(source==flagb)
      {
       selsymbol.setSymb(206);
       selsymbol.repaint();
       selsymbol.revalidate();
      leftp.revalidate();
      leftp.repaint();
      }
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}

}//end of actionPerformed

public boolean showDialog( Geditor geditor)
{  ok=false;
   if(actlayer==null)
   GeditGlobal.showErrorDialog((JFrame)geditor, "No active Layer.");
   else
     show();
     if(ok)
     {
      int sybv=selsymbol.getSymbolValue();
      updMapSymb(geditor,sybv);
      updLegend(geditor,sybv);
      }
      return(ok);
}
private void updMapSymb(Geditor gdt,int newvalue)
{
      Relation rl=gdt.maprel;
      for(int i=0;i<rl.numtuples;i++)
        { if(((String[])rl.data[gdt.pL])[i].compareTo(actlayer)==0)
	  {
	   if(curcolorv==0) curcolorv=((int[])rl.data[gdt.pC])[i];
           ((int[]) rl.data[gdt.pSymb])[i]=newvalue;
	   ((int[]) rl.data[gdt.pC])[i]=curcolorv;
	   }
        }
     try{
	rl.save();
      }catch(InterpretError ie){System.out.println("InterpretError in getRelbyName");}
}

private void updLegend(Geditor geditor, int newvalue)
{ GeditLegend[] lgdarray=(GeditLegend[])geditor.legendhtb.get(actlayer);
  GeditLegend[] newlgdarray=new GeditLegend[1];
  newlgdarray[0]=new GeditLegend(actlayer,actlayer,curcolorv,newvalue,null,null,true,true,lgdarray[0].type);
  geditor.legendhtb.remove(actlayer);
  geditor.legendhtb.put(actlayer,newlgdarray);
}
}//end of GeditSymbolEdit 

//icon of hollow oval
class Circle2Icon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public Circle2Icon(int width,int height,int ddX,int ddY){
  this.width=width;
  this.height=height;
  dX=ddX;dY=ddY;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,25,25,202,15,dX,dY);
 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}


//icon of triangle
class TriangleIcon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public TriangleIcon(int wid,int hgt,int ddX,int ddY){
width=wid;
height=hgt;
dX=ddX;dY=ddY;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,25,20,204,15,dX,dY);

 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}

//icon of triangle
class FlagIcon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public FlagIcon(int wid,int hgt,int ddX,int ddY){
width=wid;
height=hgt;
dX=ddX;dY=ddY;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,20,20,206,15,dX,dY);

 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}
//icon of hollow triangle
class HolTriangleIcon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public HolTriangleIcon(int wid,int hgt,int ddX,int ddY){
width=wid;
height=hgt;
dX=ddX;dY=ddY;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,25,20,205,15,dX,dY);

 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}

class OvalIcon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public OvalIcon(int width,int height,int ddX,int ddY){
  dX=ddX;dY=ddY;
  this.width=width;
  this.height=height;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,25,25,201,15,dX,dY);
 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}

//icon of circle
class CircleIcon implements Icon{
  int width=20; //set to default size
  int height=20;
  int dX,dY;

public CircleIcon(int width,int height,int ddX,int ddY){
  this.width=width;
  this.height=height;
  dX=ddX;
  dY=ddY;
 }

 //Paint the picture
 public void paintIcon(Component c,Graphics g,int x,int y){
 g.setColor(Color.black);
 GeditGraph.drawSymb(g,25,25,203,15,dX,dY);
 }

 //To retrieve the icon width
 public int getIconWidth(){
   return width;
   }

 //To retrieve the icon height
 public int getIconHeight(){
  return height;
  }
}


