
/**
*Class GeditValueClass.
*
* The dialog of Value Classification 
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class  GeditValueClass extends JDialog implements ActionListener,TypeConstants,ListSelectionListener{
  //Graphic components
  private JLabel activelayer;
  private JButton okbutton=new JButton("OK");
  private JButton cancelbutton=new JButton("Cancel");
  private JTextField colorvalue;
  private JTextField symbolvalue;
  private JList attrlist=null;
  private JLabel message;

  private boolean ok;
  private Hashtable lgdhtb;
  private String actlayer=null;
  private boolean toomany=false;

  public GeditValueClass(Geditor geditor,String[] allayers, Hashtable legendhtb)
  {
    super((JFrame)geditor, "Individual Value Map",true);
    ok=false;
    lgdhtb=legendhtb;

    //get active layer
    if(lgdhtb!=null)
    actlayer=GeditGlobal.getActiveLayer(geditor);
    if(actlayer!=null)
    {
    JLabel activelayer=new JLabel("Active Layer: "+actlayer);

    Domain[] doms=geditor.maprel.domains;

    //get the number of additional attributes and the name of each additonal
    //attributes
    String[] attrname=new String[doms.length];
    boolean addattr=true;
    int k=0;
    for(int i=0;i<doms.length;i++)
     { 
      addattr=true;
      for(int j=0;j<geditor.dom.length;j++)
      {if (doms[i].name.compareTo(geditor.dom[j].name)==0)
       addattr=false;
       }
       if(addattr)
       {
        attrname[k]=doms[i].name;
        k++;
       }
     }
      //if the number of additional attributes is 0, show this in the message 
      if( k==0)  message=new JLabel("There's no additional attributes");
       else message=new JLabel("Please select an attribute from above lists");

       message.setForeground(geditor.messagecolor);

     Dimension d=geditor.getSize();
     int dwid=d.width;
     int dhgt=d.height;
     int wid=dwid/2;
     int hgt=dhgt*2/5;

     attrlist=new JList(attrname);
     attrlist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
     attrlist.setFixedCellWidth(wid/5);
     attrlist.setFixedCellHeight(hgt/12);
     attrlist.addListSelectionListener(this);

     JScrollPane scrollpane=new JScrollPane(attrlist);

     //construct the button panel
     JPanel buttonp=new JPanel();
     okbutton.addActionListener(this);
     okbutton.setEnabled(false);//initially disable okbutton
     buttonp.add(okbutton);
     cancelbutton.addActionListener(this);
     buttonp.add(cancelbutton);

     JLabel titlel=new JLabel("Attribute List");
     JPanel titlep=new JPanel();
     titlep.add(titlel);

     //layout the dialog
     JPanel p=new JPanel();
     GridBagLayout gbl=new GridBagLayout();
     Container contentpane=getContentPane();
     p.setLayout(gbl);
     GridBagConstraints constraints=new GridBagConstraints();
     //constraints.weightx=100;
     //constraints.weighty=100;
     constraints.weightx=0;
     constraints.weighty=0;
     constraints.fill=GridBagConstraints.VERTICAL;
     GeditGlobal.add(p,activelayer,constraints,0,0,1,1);

     GeditGlobal.add(p,titlep,constraints,0,1,1,1);

    // constraints.fill=GridBagConstraints.NONE;
     GeditGlobal.add(p,scrollpane,constraints,0,2,1,4);

     GeditGlobal.add(p,buttonp,constraints,0,6,1,1);
     GeditGlobal.add(p,message,constraints,0,7,1,1);

     Border etched = BorderFactory.createEtchedBorder();
     p.setBorder(BorderFactory.createTitledBorder(etched,"Individual Value Map"));
    contentpane.add("Center",p);
     setSize(wid,hgt);
     }//end of if(actlayer!=null)
    }
 public void actionPerformed(ActionEvent evt)
 { Object source=evt.getSource();
     if(source==cancelbutton)
        setVisible(false);
      else if(source==okbutton)
       {ok=true;
        setVisible(false);
	}
}//end of actionPerformed

//when an item in attrlist is selected, activate the okbutton
public void valueChanged(ListSelectionEvent evt)
{
 JList source=(JList)evt.getSource();
 if(source==attrlist)
  okbutton.setEnabled(true);//activate okbutton
}

public boolean showDialog( Geditor geditor)
{  ok=false;
   if(actlayer==null)
   //JOptionPane.showMessageDialog((JFrame)geditor, "No active Layer.","Error",JOptionPane.ERROR_MESSAGE);
   GeditGlobal.showErrorDialog((JFrame)geditor,"No active layer");
   else
   {
     show();
     if(ok)//update the map 
     {
      if(toomany==true)
        JOptionPane.showMessageDialog((JFrame)geditor,
	"Too many colors(>256*256*256).","Error",JOptionPane.ERROR_MESSAGE);
      else 
     updMap( geditor);
     }
    }
     return(ok);

}

//updMap update the maprel of Geditor and change the color of the groups
//according to the different values of the selected attribute in the dialog
private  void updMap(Geditor geditor)
   {
     String slctattr=(String)attrlist.getSelectedValue();
     Hashtable htb=new Hashtable();
     String tmprelname=GeditGlobal.nextTempName("TMP");

     //tmprelname<-[attr] where L=activelayer in GeditMap;
     geditor.inter.executeRelixCommand(tmprelname+"<- [ "+slctattr+"] where  "+geditor.Lname+"=\""+actlayer+"\" in "+geditor.GeditMap+";");
     Relation tmprel=null;
     try{
     tmprel=geditor.inter.getRelbyName(tmprelname);
     geditor.inter.executeRelixCommand("dr "+tmprelname+";");
     }catch(InterpretError ie){System.out.println(ie.getMessage());}

  if(tmprel.numtuples>256*256*256)
  toomany=true;
  else{
     int [] types=tmprel.toTypes(tmprel.domains);
     Object[] data=tmprel.data;
     Object htbindex=null;

     //construct the htb which stores the value--color pairs
     int k=0;
     int clrgap=256/tmprel.numtuples;
     for (int i=0;i<tmprel.numtuples;i++)
       {
          //get the object
          htbindex=GeditGlobal.calVal(tmprel,i,0);
	  //System.out.println("256-i*clrgap="+(256-i*clrgap));
//	  Color color=new Color(i*clrgap,255-i*clrgap,i*clrgap); 
	  Color color=new Color(255-i*clrgap,i*clrgap,i*clrgap); 
	  htb.put(htbindex,color);
	  k++;
	}//end of for

     Object[] mapdata=geditor.maprel.data;
     if(mapdata==null)System.out.println("mapdata of geditor is null");
     Domain[] mapdom=geditor.maprel.domains;
     Domain slcdm=null;
     for(int i=0;i<geditor.maprel.numattrs;i++)
     {if (mapdom[i].name.compareTo(slctattr)==0)
      {
       slcdm=mapdom[i];
       break;
       }
     }
       
     int pos=geditor.maprel.indexOfDomain(slcdm); 
     types=geditor.maprel.toTypes(geditor.maprel.domains);
     Object obj=null;
     for(int i=0;i<geditor.maprel.numtuples;i++)
      {
      if(mapdata==null)System.out.println("mapdata is null");
      if(((String[])mapdata[geditor.pL])[i]==null)
         System.out.println("mapdata [i] is null");//should not happen
      if(((String[])mapdata[geditor.pL])[i].compareTo(actlayer)==0)
      {
         //get the object of row i, column pos of Geditor's maprel
         obj=GeditGlobal.calVal(geditor.maprel,i,pos);
         //get the color of this object from htb
	 Color color=(Color)(htb.get(obj));
	 int colorv=GeditColor.color2int(color);
	 //change the color value of the mapdata
         ((int[])mapdata[geditor.pC])[i]=colorv;
       }
     }//end of for
     try{
       geditor.maprel.save();
     //geditor.inter.executeRelixCommand("pr "+geditor.GeditMap+";");

      
       }catch (InterpretError ie){System.out.println(ie.getMessage());}

//update legend hashtable
//only need to update the legend of current active layer
GeditLegend[] newlgdarray=new GeditLegend[htb.size()];
GeditLegend[] lgdarray=(GeditLegend[])geditor.legendhtb.get(actlayer);

geditor.legendhtb.remove(actlayer);
Enumeration e=htb.keys();
if(e.hasMoreElements())

//construct the new legend item for the current active layer
for(int i=0;i<htb.size();i++)
{ Object htbid=e.nextElement();
  int color=GeditColor.color2int((Color)(htb.get(htbid)));
  String name=lgdarray[0].name;
  String title=lgdarray[0].title;
  int symbol=lgdarray[0].symbol;
  boolean visible=lgdarray[0].visible;
  boolean active=lgdarray[0].active;
  String type=lgdarray[0].type;
  String label=htbid.toString();
  newlgdarray[i]=new GeditLegend(name,title,color,symbol,slctattr,label,visible,active,type);
}
geditor.legendhtb.put(actlayer,newlgdarray);
}//end of else
}//end of updMap
}//end of GeditValueClass
