
/**
*Class Geditor.
*
* It's the Gedit controler that layouts different components and calls the
* methods of Gedit.
*
* @author YuLing Chen
* October, 2000
*/
import javax.swing.*;          //This is the final package name.
//import com.sun.java.swing.*; //Used by JDK 1.2 Beta 4 and all
                               //Swing releases before Swing 1.1 Beta 3.
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.math.*;
import javax.swing.BorderFactory; 
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;


public class Geditor extends JFrame implements TypeConstants,ActionListener {

  
    public Interpreter inter;   
    public Hashtable legendhtb;
    public Domain[] dom;//graphical domains(G,T,S,X,Y,C,Symb,L)

    public String GeditMap;//name of the maprelation(containing whole map)
    public String SelMap;//name of the map which shows selected map
                         //features(whole map) 
    public String ActLRel;//name of the relation containing only active layer
    public String SelRel;//name of the relation containing only selected map features from Expression Builder
    public String SpqRel;//name of the relation containing only selected map features from Spatial Query
    public String ValueRel;//name of the relation containing value of
    //"Within Distance Of" operator in Spatial Query
    public Relation maprel;//Relation of  GeditMap
    public Relation selmaprel;//Relation of SelMap
    public Relation selrel=null;//Relation of  SelRel
    public Relation spqrel=null;//Relation of  SpqRel
    public Relation actlrel=null;//Relation of ActLRel


    public String[] showlayers=null;//layers currently shown
    public int[] minmax=new int[4];//minx,miny,maxx,maxy of the maprel
    public String Lname; //attribute name of Layers

    //position of graphical attributes
    public int pG=-1;
    public int pT=-1;
    public int pS=-1;
    public int pX=-1;
    public int pY=-1;
    public int pC=-1;
    public int pSymb=-1;
    public int pL=-1;
    public Dimension d;

    //the color shows the map features selected by Expression Builder
    public int selcolor=255255000;

    //the color shows the map features selected by Spatial Query
    public int spqcolor=255051051;

    //the color shows the active layers in the legend splitpane
    public int activecolor=255255000;

    public String[] allayers={""};;
    private Domain layerdom=null ;
    private int wid,hgt;

    private JDesktopPane desktop=null;
    private GeditAddLayers addialog=null;
    private JInternalFrame f=null;
    private JCheckBox[] title=null;
    private JScrollPane legendscp=null;
    private JSplitPane sp=null;
    private JPanel legendp=null;
    private GeditLayerControl lctldialog=null;
    private GeditColorEdit colordialog=null;
    private GeditSymbolEdit symboldialog=null;
    private GeditValueClass vcdialog=null;
    private GeditRangeClass rcdialog=null;
    private GeditExpression exbuilder=null;
    private GeditOptions option=null;
    private GeditLegendEdit lgdeditor=null;
    private GeditSpatialQ  spquery=null;
    private GeditAbout about=null;
    public GeditIdentify identf=null;

    //CvDraw is the class that shows the map
    public CvDraw Cdr;

    //symbitem is the menu item that allows the user to edit the symbols of
    //points. It's only active when the current active layer is point.
    public JMenuItem symbitem;
    public Color messagecolor=new Color(153,0,0);

    private boolean windowclose= false;
    private int dX,dY;
    private String helpfilename="chapter2.ps";


    //constructor 
    public Geditor(Interpreter interpt, Relation rl, Domain[] doms) {

    super("Geditor");

    setFont(new Font("Serif",Font.PLAIN,40));

    Relation tmprel=rl;
    dom=doms;
    inter=interpt;

    //get the attributes positions of Color, Symbol and Layer
    pG=rl.indexOfDomain(dom[0]);
    pT=rl.indexOfDomain(dom[1]);
    pS=rl.indexOfDomain(dom[2]);
    pX=rl.indexOfDomain(dom[3]);
    pY=rl.indexOfDomain(dom[4]);
    pC=rl.indexOfDomain(dom[5]);
    pSymb=rl.indexOfDomain(dom[6]);
    pL=rl.indexOfDomain(dom[7]);
    Domain[] domains=rl.domains;

   //get the attr name of layer in maprelation;
    Lname=(tmprel.domains)[pL].name;

   //get the name of the maprelation;
    String maprelname=rl.name;

   layerdom=domains[pL]; 

   //initiate GeditMap and SelMap; Separate GeditMap from SelMap so as to
   //clear the selection by Querying the Map
   GeditMap=GeditGlobal.nextTempName("Map");
   String tmpstr=GeditMap+" <- "+maprelname+";";

   //Since the following three maps need to be accessed by aldat programmer
   //the names must be fixed
   SelMap=GeditGlobal.nextTempName("Sel");
   SelRel="SelRel";
   SpqRel="SpqRel";
   ActLRel="ActLRel";
   ValueRel="ValueRel";


   //maprel is the copy of the maprelation passed to Geditor;
   //Geditor does not write the maprelation, all written operations are
   //performed on maprel
   try{
   //get a copy of maprelation to GeditMap
   String ttt=GeditMap+" <- "+maprelname+";";
   //System.out.println(ttt);
   inter.executeRelixCommand(GeditMap+ " <- "+maprelname+";");
     maprel=inter.getRelbyName(GeditMap);
       }catch (InterpretError ie){System.out.println(ie.getMessage());}

   //copy GeditMap to SelMap
   initSelMap();
   initActLRel();
   GeditGlobal.delRelation(inter,SelRel);
   //rmSelRel();

    //calculate the min, max points in maprelation
    try{
    minmax=getMinMax(maprel);
    }catch(GeditError ge){System.out.println(ge.getMessage());}

    //calculate the dimension of Geditor
    Dimension d=getToolkit().getScreenSize();
    dX=d.width;dY=d.height;
    setSize(d.width-30,d.height-30);

    desktop= new JDesktopPane();
    setContentPane(desktop);

    //set the menu bar
    setJMenuBar(createMenuBar(this));

   //Add Window Listener.
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
	        if(GeditMap!=null)
		 GeditGlobal.delRelation(inter,GeditMap);
		 GeditGlobal.delRelation(inter,SelMap);
	         //inter.executeRelixCommand("dr "+GeditMap+";");
	         //inter.executeRelixCommand("dr "+SelMap+";");
                return;
            }
        });

   //get the layer names in GeditMap
   String relname=GeditGlobal.nextTempName("TMP");
   inter.executeRelixCommand(GeditMap+ " <- "+maprelname+";");
   inter.executeRelixCommand(relname+ "<-["+Lname+"] in "+GeditMap+";");
   try{
     Relation temprel=inter.getRelbyName(relname);
     allayers=(String[])(temprel.data)[0];
     inter.executeRelixCommand("dr "+relname+";");//delete the temprel
       }catch (InterpretError ie){System.out.println(ie.getMessage());}

       //Construct the legend hashtable

       legendhtb=new Hashtable();
       String TattrName=dom[1].name;
       String CattrName=dom[5].name;
       String SymbattrName=dom[6].name;
       String LattrName=dom[7].name;

       //tprelname<-[L,T,C,Symb] in GeditMap

       String tprelname=GeditGlobal.nextTempName("TMP");
       inter.executeRelixCommand(tprelname+"<-["+LattrName+","+TattrName+","+CattrName+","+SymbattrName+"] in "+GeditMap+";");
       Relation tprel=null;
       try{
       tprel=inter.getRelbyName(tprelname);
       inter.executeRelixCommand("dr "+tprelname+";");
       }catch(InterpretError ie){System.out.println(ie.getMessage());}

       String layername=null;
       String curlayername=null;
       Object[] tpdata=tprel.data;
       int i=0;
       boolean breakflag=false;
       while(i<(tprel.numtuples-1))
       {
       if(tpdata==null)System.out.println("tpdata is null");//never happen
        layername=((String[])tpdata[0])[i];
        int pos=i;
        breakflag=false;
        while (i<(tprel.numtuples-1))
	  {i++;
	   curlayername=((String[])tpdata[0])[i];
	   if(curlayername.compareTo(layername)!=0)
	   { 
	   breakflag=true;
	   break;}
	  }
	GeditLegend [] legendarray=new GeditLegend[i-pos];
	for(int j=pos;j<i;j++)
	  { 
	    String typename=((String[])tpdata[1])[j];
	    int colorvalue=((int[])tpdata[2])[j];
	    int symbvalue=((int[])tpdata[3])[j];
	    GeditLegend legendrd=new GeditLegend(layername,layername,colorvalue,symbvalue,null,null,false,false,typename);
	    legendarray[j-pos]=legendrd;
	  }//end of for
	legendhtb.put(layername,legendarray);
      } //end of while

      if(breakflag||tprel.numtuples==1) //process the last layer
      {
       if(tpdata==null)System.out.println("tpdata is null");//never happen
        if(tprel.numtuples==1)
        layername=((String[])tpdata[0])[0];
        else layername=curlayername;
	GeditLegend [] legendarray=new GeditLegend[1];
	    String typename=((String[])tpdata[1])[tprel.numtuples-1];
	    int colorvalue=((int[])tpdata[2])[tprel.numtuples-1];
	    int symbvalue=((int[])tpdata[3])[tprel.numtuples-1];
	    GeditLegend legendrd=new GeditLegend(layername,layername,colorvalue,symbvalue,null,null,false,false,typename);
	    legendarray[0]=legendrd;
	    legendhtb.put(layername,legendarray);
      }

	
	//create the Map View internal frame
       legendp=new JPanel();
       legendscp=new JScrollPane(legendp);
       f=new JInternalFrame("Map View",true,false,true,true);
        wid=getSize().width;
        hgt=getSize().height;

       //the size of Map View is 3/4 of the screen
       f.setBounds(0,0,(wid*3/4),(hgt*3/4));
       Cdr=new CvDraw(null,dom,minmax);
       Cdr.setBackground(new Color(199,199,199));

       //the size of left legend split window
       int lwid=wid*3/24;
       int lhgt=hgt*3/4;

       legendscp.setPreferredSize(new Dimension(lwid,lhgt));
       sp=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,legendscp,Cdr);

       f.getContentPane().add("Center",sp);
       setVisible(true);
       desktop.add(f,new Integer(1));

      }//end of constructor()

//construct the menubar of Gedit window
private  JMenuBar createMenuBar(Object target){

        //add menubar
        JMenuBar mbr=new JMenuBar();
        JMenu unimenu=new JMenu("Uniform Layer");
        JMenuItem coloritem=new JMenuItem("Color Editor");

	unimenu.add(coloritem);
	coloritem.addActionListener((ActionListener)target);
	unimenu.addSeparator();
	symbitem=new JMenuItem("Symbol Editor");
	unimenu.add(symbitem);
	symbitem.addActionListener((ActionListener)target);

	JMenu thematicmenu=new JMenu("Thematic Mapping");
	JMenuItem valueitem=new JMenuItem("Individual Value Map");
	valueitem.addActionListener((ActionListener)target);
	JMenuItem rangeitem=new JMenuItem("Range Map");
	rangeitem.addActionListener((ActionListener)target);
	thematicmenu.add(valueitem);
	thematicmenu.addSeparator();
	thematicmenu.add(rangeitem);

	mbr.add(makeMenu("Layers                   ",new Object[]{"Add Layer",null, "Layer Control",null, "Exit"},target));
	mbr.add(makeMenu("View                  ",new Object[]{unimenu,null, thematicmenu,null, "Legend Editor"},target));
        mbr.add(makeMenu("Query                  ",new Object[]{"Identify Tool",null, "Expression Builder",null, "Spatial Query", null, "Clear Selections",null,"Options"},target));
	mbr.add(makeMenu("Help                  ",new Object[]{"User's Manual", null, "About"},target));
	return mbr;
}

public void actionPerformed(ActionEvent evt)
{ String arg=evt.getActionCommand();
  if(arg.equals("Exit"))
  {
   //delete the GeditMap and SelMap
   //inter.executeRelixCommand("dr "+GeditMap+";");
   //inter.executeRelixCommand("dr "+SelMap+";");
   GeditGlobal.delRelation(inter, GeditMap);
   GeditGlobal.delRelation(inter,SelMap);
   GeditGlobal.delRelation(inter, SelRel);
   GeditGlobal.delRelation(inter, SpqRel);
   GeditGlobal.delRelation(inter, ValueRel);
   //rmSelRel();
   //rmSpqRel();
   //rmValueRel();
   setVisible(false);
   }
  else if(arg.equals("Add Layer"))
    {
    addialog=new GeditAddLayers(this,allayers,showlayers,legendhtb); 
    addialog.setLocationRelativeTo(this);

	  if(addialog.showDialog(this))
	    if(legendhtb!=null)
	     {updateMapView(GeditMap);
 	      updateLegend();}
	     else{System.out.println("legendarray is null");}
    }
  else if(arg.equals("Layer Control"))
  {
   lctldialog=new GeditLayerControl(this,allayers,legendhtb);
   lctldialog.setLocationRelativeTo(this);
   if(lctldialog.showDialog(this))
   {updateLegend();}
  }
  else if(arg.equals("Color Editor"))
  {
   colordialog=new GeditColorEdit(this,allayers,legendhtb);
   colordialog.setLocationRelativeTo(this);
   if(colordialog.showDialog(this))
    {updateMapView(GeditMap);
     updateLegend();}
   }
  else if(arg.equals("Symbol Editor"))
  {
   symboldialog=new GeditSymbolEdit(this,allayers,legendhtb);
   symboldialog.setLocationRelativeTo(this);
   if(symboldialog.showDialog(this))
   {updateMapView(GeditMap);updateLegend();}
   }
  else if(arg.equals("Individual Value Map"))
  {
  vcdialog=new GeditValueClass(this,allayers,legendhtb);
  vcdialog.setLocationRelativeTo(this);
  if(vcdialog.showDialog(this))
   {updateMapView(GeditMap);updateLegend();}
   }
   else if(arg.equals("Range Map"))
   {
   rcdialog=new GeditRangeClass(this,allayers,legendhtb);
   rcdialog.setLocationRelativeTo(this);
   if(rcdialog.showDialog(this))
    {updateMapView(GeditMap);updateLegend();}
    }
    else if(arg.equals("Identify Tool"))
    {
    if(identf==null)
    {identf=new GeditIdentify(this,allayers,legendhtb);
     if(identf.actlayer!=null)
     {
     identf.setBounds(wid/12,hgt/12,(wid/6),(hgt/4));
     desktop.add(identf,new Integer(1));
      identf.show();
	  identf.setVisible(true);
      }
      else GeditGlobal.showErrorDialog((JFrame)this,"No active Layer");
     }
    else {
          if(identf.actlayer!=null)
	  {
            identf.init();
            identf.show();
	    identf.setVisible(true);
	  }
          else GeditGlobal.showErrorDialog((JFrame)this,"No active Layer");
	}
    }
    else if(arg.equals("Expression Builder"))
    {
     exbuilder=new GeditExpression(this,allayers);
     exbuilder.setLocationRelativeTo(this);
     if( exbuilder.showDialog())
     {//update the mapview with the SelMap which shows temporay selections 
      //need not to update legend window
        updateMapView(SelMap);      
     }
    }
    else if(arg.equals("Legend Editor"))
    {
     lgdeditor=new GeditLegendEdit(this,allayers);
     lgdeditor.setLocationRelativeTo(this);
     if(lgdeditor.showDialog())//only need to update legend window
      updateLegend();
    }
    else if(arg.equals("Options"))
    {
     option=new GeditOptions(this);
     option.setLocationRelativeTo(this);
     option.showDialog();
    }
    else if(arg.equals("Clear Selections"))
    {
    //update mapview with GeditMap
    initSelMap();
    GeditGlobal.delRelation(inter,SelRel);
    GeditGlobal.delRelation(inter,SpqRel);
    //rmSelRel();
    //rmSpqRel();
    updateMapView(GeditMap);

    }
    else if(arg.equals("Spatial Query"))
    {
    spquery=new GeditSpatialQ(this,allayers);
     spquery.setLocationRelativeTo(this);
     if(spquery.showDialog())//update mapview with SelMap
      updateMapView(SelMap);

    }
    else if(arg.equals("User's Manual"))
    {
    Runtime rt=Runtime.getRuntime();
    try{
         String command="gv "+helpfilename;
	 Process pr=rt.exec(command);
        }catch(IOException e){System.out.println("error");}
    }
    else if(arg.equals("About"))
    {
     about=new GeditAbout(this);
     about.setLocationRelativeTo(this);
     about.showDialog();
    }

}//end of actionPerformed

private static JToolBar createToolBar(){

        //Add toolbar
        JToolBar tb=new JToolBar();
        JButton newButton =new JButton(new ImageIcon("save.gif"));
        JButton cutButton =new JButton(new ImageIcon("paste.gif"));
        JButton copyButton =new JButton(new ImageIcon("copy.gif"));

        tb.add(newButton);
        tb.add(cutButton);
        tb.add(copyButton);

        newButton.setMnemonic(KeyEvent.VK_I);
         newButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });

	return(tb);

}


  //getMinMax returns minX,minY,maxX,maxY in Relation rel
  private  int []  getMinMax(Relation rel )
  throws GeditError
   {
     int[] minmax={0,0,0,0};
     Object[] data=rel.data;
     Domain[] doms=rel.domains;
     int iX=0,iY=0;
     int minX=0,minY=0,maxX=0,maxY=0;

     int numtuples=rel.numtuples;

     int[] types = rel.toTypes(doms);//domain types
     for (int i=0;i<numtuples;i++)
     {

      if(types[pX]!=INTEGER){throw new GeditError("expecting type INTEGER");}
      else
        iX=((int[])data[pX])[i];

      if(types[pY]!=INTEGER){throw new GeditError("expecting type INTEGER");}
        iY=((int[])data[pY])[i];
      
      if(i==0) {minX=iX;maxX=iX;minY=iY;maxY=iY;}//first row
        else
	  {
            if (iX<minX) minX=iX;
	    if (iX>maxX) maxX=iX;
	    if (iY<minY) minY=iY;
	    if (iY>maxY) maxY=iY;
	  }

     }//end of for loop

     minmax[0]=minX;
     minmax[1]=maxX;
     minmax[2]=minY;
     minmax[3]=maxY;
     return(minmax);
 }//end of getMinMax

//makeMenu and makeMenuItem helps to construct the menu bar of Gedit window
public static JMenu makeMenu(Object parent, Object[] items, Object target)
{ JMenu m=null;
  if (parent instanceof JMenu)
    m=(JMenu)parent;
  else if(parent instanceof String)
    m= new JMenu((String)parent);
  else return null;

  for(int i=0;i<items.length;i++)
  {  if(items[i]==null)
      m.addSeparator();
     else
      m.add(makeMenuItem(items[i],target));
  }
  return m;
}

public static JMenuItem makeMenuItem(Object item, Object target)
{JMenuItem r=null;
 if(item instanceof String)
    r= new JMenuItem((String)item);
 else if(item instanceof JMenuItem)
    r= (JMenuItem)item;
 else return null;

 if(target instanceof ActionListener)
    r.addActionListener((ActionListener)target);
 return r;
}

//updateMapView updates the mapview(drawn by Cdr) according to the relation
//indicated by mapname
private  void updateMapView(String mapname)
{

	     
	   //get the position of layer attribute in maprel
	   int layerpos=maprel.indexOfDomain(layerdom);


	  if(showlayers!=null)
	  {

	   //put the tuples of showlayers in separate relations so that the
	   //geditor can display them one after the other according the
	   //sequence in showlayers array 

	   Relation[] relarray=new Relation[showlayers.length];

	   //rl contains all the shown layers in maprel
	   Relation rl=null;

	   try{
	   for(int i=0;i<showlayers.length;i++)
	   {
	     int randm=new Random().nextInt();
	     String tmpname="rel"+Math.abs(randm);
	     String commd=tmpname+" <- where "+Lname+"= \""+showlayers[i]+"\" in "+mapname+";";
	     inter.executeRelixCommand(commd);
	     relarray[i]=inter.getRelbyName(tmpname);
	     inter.executeRelixCommand("dr "+tmpname+";");
	    }
	    if (relarray.length!=0)
	      rl=relarray[0];
	    if(showlayers.length>1)
	     { 
	     for(int i=1;i<showlayers.length;i++)
	      {
	      //append relarray[i] to rl without projection
	      rl.appendInRAM2(relarray[i],rl); 
	      }
	      }
	      
	   }catch (InterpretError ie){System.out.println(ie.getMessage());}


           //update the Map
           Cdr.setData(rl,dom,minmax);
	   }
}//end of updateMapView()

//updateLegend update the legend split window
private void updateLegend()
{

  if(showlayers!=null)
    {
           //update the legend window
	   legendp.removeAll();
	   legendp.setLayout(new BorderLayout(10,10));

           title=new JCheckBox[allayers.length];

           JPanel legendpl=new JPanel();
	   legendpl.setLayout(new BorderLayout(10,10));

	   JPanel legendbox=new JPanel();
	   GridBagLayout gridbl=new GridBagLayout();
           legendbox.setLayout(gridbl);
	   GridBagConstraints cons=new GridBagConstraints();

	   cons.weightx=0;
	   cons.weighty=0;
	   cons.ipady=0;
	   cons.gridwidth=1;
	   cons.gridheight=1;
	   cons.anchor=GridBagConstraints.WEST;

       for(int i=0;i<allayers.length;i++)
        { 
	   GeditLegend[] legendarray=(GeditLegend[])legendhtb.get(allayers[i]);
            if(legendarray[0].getVisible())	
	      title[i]=new JCheckBox(legendarray[0].title,true);
	    else
	      title[i]=new JCheckBox(legendarray[0].title,false);

           String[] slayerarray=new String[1];
           slayerarray[0]=legendarray[0].name;
	     
	   JPanel legendpanel=new JPanel();
	   GridBagLayout gbl=new GridBagLayout();
	   GridBagConstraints constraints=new GridBagConstraints();
	   legendpanel.setLayout(gbl);

	   constraints.weightx=100;
	   constraints.weighty=100;
	   constraints.gridwidth=1;
	   constraints.gridheight=1;
	   constraints.anchor=GridBagConstraints.WEST;
	   //show label attr
	   if(legendarray[0].labelattr!=null)
	   {
	     constraints.ipadx=10;
	     constraints.anchor=GridBagConstraints.WEST;
	     JLabel labeltitle=new JLabel(legendarray[0].labelattr);
	     GeditGlobal.add(legendpanel,labeltitle,constraints,1,0,1,1);
           }

          for(int j=0;j<legendarray.length;j++)
	  {
	   int color=legendarray[j].color;
	   int symbol=legendarray[j].symbol;
	   String type=legendarray[j].type;
	   String label=legendarray[j].label;
	   Dimension dim=legendscp.getSize();
	   int wid=(int)(dim.width*(((double)(1))/((double)10)));
           GraphLegend graphlegend=new GraphLegend(type,color,symbol,wid,dX,dY);
	    constraints.ipady=10;
	    constraints.ipadx=10;
	    constraints.anchor=GridBagConstraints.WEST;
	    GeditGlobal.add(legendpanel,graphlegend,constraints,0,j+1,1,1);
	    if(label!=null)
	      {
              JLabel labl=new JLabel(label);
	      constraints.ipadx=10;
	      GeditGlobal.add(legendpanel,labl,constraints,1,j+1,1,1);
	      }
	    }
	   //end of for

	   boolean active=legendarray[0].active;
	    if(active)
	      title[i].setBackground(GeditColor.int2color(activecolor));

	   title[i].setAlignmentX(LEFT_ALIGNMENT);
           title[i].addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
	      for(int j=0;j<title.length;j++)
                { String argevt=e.getActionCommand();
		  if(argevt.equals(title[j].getLabel()))
		  {
		  boolean set=title[j].isSelected();
		  if(set) set=false;
		  else set=true;
                  title[j].setSelected(set);
		  }
		}
		
		}});
           JPanel titlepanel=new JPanel();

	    titlepanel.setLayout(new BorderLayout());
            titlepanel.add("West",title[i]);
	    titlepanel.setMaximumSize(getPreferredSize());

           if(i!=0) cons.ipady=10;
	   else cons.ipady=0;
	   cons.gridwidth=1;
	   cons.gridheight=1;
	   cons.gridx=0;
	   cons.gridy=i*2;
	   cons.anchor=GridBagConstraints.WEST;
	   cons.fill=GridBagConstraints.NONE;
           legendbox.add(titlepanel,cons);
	   cons.gridx=0;
	   cons.gridy=i*2+1;
	   cons.gridwidth=1;
	   cons.gridheight=1;
	   cons.anchor=GridBagConstraints.WEST;
           legendbox.add(legendpanel,cons);

	   titlepanel.revalidate();
	   legendpanel.revalidate();
	}
	legendpl.revalidate();
	legendpl.add("North",legendbox);
	legendpl.repaint();
	legendp.revalidate();
	legendp.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
	legendp.add("West",legendpl);
	legendp.repaint();

   }//end of if showlayers!=null

}//end of updateLegend()
public void initSelMap()
{
   String tmpstrsel=SelMap+" <- "+GeditMap+";";
   try{
   inter.executeRelixCommand(tmpstrsel);//get a copy of maprelation to SelMap
   selmaprel=inter.getRelbyName(SelMap);
   }catch(InterpretError ie){System.out.println(ie.getMessage());}
}

//initiate the ActLRel
public void initActLRel()
{
   String tmpstrsel= ActLRel+" <- "+GeditMap+";";
   try{
   inter.executeRelixCommand(tmpstrsel);//get a copy of maprelation to SelMap
   actlrel=inter.getRelbyName(ActLRel);
   }catch(InterpretError ie){System.out.println(ie.getMessage());}

}

//remove the SelRel
/*public void rmSelRel()
{
   String tmpstr="dr "+SelRel+";";
   inter.executeRelixCommand(tmpstr);
}*/

//remove the SpqRel
/*public void rmSpqRel()
{
   String tmpstr="dr "+SpqRel+";";
   inter.executeRelixCommand(tmpstr);
}*/
//remove the ValueRel
/*public void rmValueRel()
{
   String tmpstr="dr "+ValueRel+";";
   inter.executeRelixCommand(tmpstr);
}*/
}//end of class Geditor


//GraphLegend is the class of the graphical icon of the legend
class GraphLegend extends JPanel
{
  private String tp="";
  private int clr=0;
  private int symb=0;
  private int wid=0;
  private int dX,dY;

  public GraphLegend(String type,int color,int symbol,int width,int ddX,int ddY)

  {   tp=type;
      clr=color;
      symb=symbol;
      wid=width;
      dX=ddX;
      dY=ddY;
  }

  public void paintComponent(Graphics g)
  {
  super.paintComponent(g);

   if(tp.toUpperCase().equals("POINT"))
     {
      GeditGraph.chooseColor(g,clr);
       if(symb==203||symb==204||symb==206)
         GeditGraph.drawSymb(g,30,10,symb,15,dX,dY);
       else
         GeditGraph.drawSymb(g,40,30,symb,15,dX,dY);

 //     GeditGraph.drawSymb(g,wid,wid/2,symb,wid);
     }
   else if(tp.toUpperCase().equals("POLYGON"))
     { 
       GeditGraph.chooseColor(g,clr);
       int [] xval={0,40,40,0};
       int [] yval={0,0,20,20};
       g.fillPolygon(xval,yval,xval.length);
     }
   else if(tp.toUpperCase().equals("POLYLINE"))
     {
       GeditGraph.chooseColor(g,clr);
       g.drawLine(0,20,13,0);
       g.drawLine(13,0,26,20);
       g.drawLine(26,20,40,0);
     }
 }

 public Dimension getMinimumSize(){return getPreferredSize();}

 public Dimension getMaximumSize(){return getPreferredSize();}
 public Dimension getPreferredSize(){return (new Dimension(40,40));}


 }//end of class GraphLegend 



