
/**
 * This class wraps the Parser for better error message display.
 * 
 */
class JRelixParser extends Parser {

/**
 * JRelixParser constructor comment.
 * @param stream java.io.InputStream
 */
public JRelixParser(java.io.InputStream stream) {
	super(stream);
}
/**
 * JRelixParser constructor comment.
 * @param tm ParserTokenManager
 */
public JRelixParser(ParserTokenManager tm) {
	super(tm);
}
/**
 * This method overwrites the superclass method for better error message display.
 * modified by Yi Zheng Sept 29, 2002
 */
protected void token_error()  {
	Global.println("Parse error at line " + error_line + ", column " + error_column + ".");
	Global.println("Offending line: ");
	String offendLine = Global.jin.getText().toString();
	Global.print(offendLine + "\n");
	StringBuffer esb = new StringBuffer("");
	for (int i = 0; i < error_column-1; i++)
		esb.append(" ");
	esb.append('^');
	for (int j = error_column-1; j < offendLine.length(); j++)
		esb.append(" ");
	Global.println(esb.toString());

	Global.println("Encountered : \"" + jj_add_escapes(error_string) + "\"");
	if (expected_tokens.length == 1) {
	  Global.println("Expecting:");
	} else {
	  Global.println("Expecting one of:");
	}
	for (int i = 0; i < expected_tokens.length; i++) {
	  Global.print(" " + expected_tokens[i]);
	}
	Global.println(""); Global.flush(); 
}
}