import java.util.*;
public class NREnvironment implements TypeConstants
{  public int row;
   public Object[] data;
   private NREnvironment parent;
   private Environment env;
   private Hashtable table;

   public int callpreEventH; // Weizhong
   public int callpostEventH; // Weizhong


   public NREnvironment(Relation rel, NREnvironment parent, Environment env)
   {  this.parent = parent;
	  this.env = env;
	  data = rel.data;
	  row = 0;
	  callpreEventH = 0;
	  callpostEventH = 0;
	  //Put all domains in the NRenv sotred as NRInfo objects
	  table = new Hashtable();
	  for(int i=0; i<rel.numattrs; i++)
	  {  Domain d = rel.domains[i];
		 table.put(d.name, new NRInfo(d.type, i, this));
	  }
   }   
   public NREnvironment getParent()
   {  return parent;
   }   
   public NRInfo lookup(String name, boolean searchParent)
   {  NRInfo nri;
	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {  return nri;
	  }
	  if(searchParent && parent!=null)  //search parent NRenv
	  {  return parent.lookup(name, searchParent);
	  }
	  return null; //name is not in the NRenv
   }   
   public Relation lookupRel(String name)
   throws InterpretError
   { 
	if (name == null) return null; //added by Yi Zheng May 27, 2002
 NRInfo nri;
	//DEBUGGING
//	System.out.println("in NREnvironment.lookupRel() for " + name);
	 IDInfo lkupID = (IDInfo) table.get(name); //Yi Zheng May 27, 2002
	 if ((lkupID != null) && (lkupID instanceof NRInfo) && ((((NRInfo)lkupID).type == IDLIST) || (((NRInfo)lkupID).type == COMP))) //Yi Zheng May 27, 2002
//	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {  
		//DEBUGGING
//		System.out.println("found NRInfo for " + name);
		nri = (NRInfo) lkupID;
		//extract the nested relation
		 long surrogate = ((long[]) data[nri.index])[row];

//System.out.println("in lookupRel extracting the nested relation, surrogate: " + surrogate + " row: " + row + " nri.index: " + nri.index);

		 if(nri.type == IDLIST)
		 {  Relation dom = env.lookupRel("."+name, true);

//System.out.println("before getRelation, name: " + name + " surrogate: " + surrogate);
//System.out.println("before getRelation, dom.name: " + dom.name + " dom.numtuples: " + dom.numtuples + " dom.numattrs: " + dom.numattrs);

			dom.load();	// Weizhong Sun

			//DEBUGGING
			//System.out.println("In NR:lookupRel for " + name + " on sur: " + surrogate);
			//dom.print();
			//dom.load(true);
		//	System.out.println("dom.getRelation returns:");
	//		Relation rdom = dom.getRelation(surrogate);
	//		rdom.print();
			//END DEBUGGING
			return dom.getRelation(surrogate);
		 }
		 else if(nri.type == COMP)
		 {  return Global.comptable.lookup(surrogate);
		 }
		 //REVISIT: view table....
	  }
	  if(parent != null)  //search parent NRenv
	  {  return parent.lookupRel(name);
	  }
	  return null; //name is not in the NRenv
   }   
   // Weizhong Sun
   public Relation lookupNestedRel(String name, int rrow)
   throws InterpretError
   {  NRInfo nri;

//System.out.println("in NestedlookupRel"  + " row: " + row + " rrow: " + rrow);
//System.out.println("in NestedlookupRel"  + " name: " + name);

	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {  //extract the nested relation
		row = rrow;

//System.out.println("in NestedlookupRel name: " + name + " nri.index: " + nri.index + " row: " + row);

//		 long surrogate = ((long[]) data[nri.index])[row];
//System.out.println("in NestedlookupRel extracting the nested relation, surrogate: " + surrogate + " row: " + row + " nri.index: " + nri.index);

		 if(nri.type == IDLIST)
		 {  Relation dom = env.lookupRel("."+name, true);

//System.out.println("before return in NREnv.lookupNestedRel, name: " + name);
//System.out.println("before return in NREnv.lookupNestedRel, dom.name: " + dom.name + " dom.numtuples: " + dom.numtuples + " dom.numattrs: " + dom.numattrs);

			return dom;
		 }
//		 else if(nri.type == COMP)
//		 {  return Global.comptable.lookup(surrogate);
//		 }
		 //REVISIT: view table....
	  }
//System.out.println("parent"  + " row: " + row + " rrow: " + rrow);
	  if(parent != null)  //search parent NRenv
	  {  return parent.lookupNestedRel(name, rrow);
	  }
	  return null; //name is not in the NRenv
   }   
   public Relation lookupRelSurr(String name)
   throws InterpretError
   {  NRInfo nri;
	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {  //extract the nested relation

//System.out.println("in lookupRelSurr extracting the nested relation" + " row: " + row + " nri.index: " + nri.index);

		 long surrogate = ((long[]) data[nri.index])[row];

//System.out.println("in lookupRelSurr extracting the nested relation, surrogate: " + surrogate);

		 if(nri.type == IDLIST)
		 {  Relation dom = env.lookupRel("."+name, true);

/*
int idcol = 0;
for (int i = 0; i < dom.numattrs; i++) {
	if ((dom.domains[i].name).compareTo(".id") == 0)
		idcol = i;
}
System.out.println("idcol in lookupRelSurr: " + idcol);
		 long surrogate = ((long[]) data[idcol])[row];
*/

//System.out.println("before getRelwithSurr, name: " + name + " surrogate: " + surrogate);

//System.out.println("before getRelationwithSurr, dom.name: " + dom.name + " dom.numtuples: " + dom.numtuples + " dom.numattrs: " + dom.numattrs);
			if(dom == null)
				throw new InterpretError("relation ." + name + " not found");//Yi Zheng June 3, 2002
			dom.load();	// Weizhong Sun

			return dom.getRelwithSurr(surrogate);
		 }
//		 else if(nri.type == COMP)
//		 {  return Global.comptable.lookup(surrogate);
//		 }
		 //REVISIT: view table....
	  }
	  if(parent != null)  //search parent NRenv
	  {  return parent.lookupRelSurr(name);
	  }
	  return null; //name is not in the NRenv
   }   

  // Weizhong, for certain surrogate
   public Relation lookupRelSurr(String name, long surrogate)
   throws InterpretError
   {  NRInfo nri;
	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {  //extract the nested relation
		 if(nri.type == IDLIST)
		 {  Relation dom = env.lookupRel("."+name, true);

/*
int idcol = 0;
for (int i = 0; i < dom.numattrs; i++) {
	if ((dom.domains[i].name).compareTo(".id") == 0)
		idcol = i;
}
System.out.println("idcol in lookupRelSurr: " + idcol);
		 long surrogate = ((long[]) data[idcol])[row];
*/

//System.out.println("in NEW func.before getRelwithSurr, name: " + name + " surrogate: " + surrogate);

//System.out.println("before getRelationwithSurr, dom.name: " + dom.name + " dom.numtuples: " + dom.numtuples + " dom.numattrs: " + dom.numattrs);

			dom.load();	// Weizhong Sun

			return dom.getRelwithSurr(surrogate);
		 }
	  }
	  if(parent != null)  //search parent NRenv
	  {  return parent.lookupRelSurr(name, surrogate);
	  }
	  return null; //name is not in the NRenv
   }   
 
   // Weizhong Sun
   public long getSurrogate(String name)
   throws InterpretError
   {  NRInfo nri;
	  if ( (nri = (NRInfo) table.get(name)) != null )
	  {
//System.out.println("in getSurrogate," + " row: " + row + " nri.index: " + nri.index);
		 long surrogate = ((long[]) data[nri.index])[row];
		 return surrogate;
   	  }
	  if(parent != null)
	  	return parent.getSurrogate(name);
	  return -1;
   }   
   
   //Yi Zheng June 3, 2002
   public void setSurrogate(String name, long sur)
   throws InterpretError
   {
   	NRInfo nri;
   	if((nri = (NRInfo) table.get(name)) != null)
   	{
   		((long[]) data[nri.index])[row] = sur;
   		return;
   	}
   	if(parent != null)
   		parent.setSurrogate(name, sur);
   }
}
