class StateInfo_2002 extends IDInfo implements TypeConstants
{
   public int intVal = 0;
   public long longVal = 0;
   public float floatVal = 0;
   public double doubleVal = 0;
   public String stringVal = "";
   public Relation relVal = null; //for storing IDLIST typed states
   public number numberVal = new number("+000+0"); //from Yiyi

   public void setVal(int type, Object val) throws InterpretError
   {  
	  if(val != null)
	  {  switch (type)
		 {  case BOOLEAN :
			   intVal = (((Boolean) val).booleanValue() == true) ? 1 : 0;
			   break;
			case NUMERIC: //from Yiyi
       			numberVal = (number) val;
               break;

			case SHORT :
			   intVal = ((Short) val).shortValue();
			   break;
			case INTEGER :
			   intVal = ((Integer) val).intValue();
			   break;
			case LONG :
			   longVal = ((Long) val).longValue();
			   break;
			case FLOAT :
			   floatVal = ((Float) val).floatValue();
			   break;
			case DOUBLE :
			   doubleVal = ((Double) val).doubleValue();
			   break;
			case STRING :
			   stringVal = (String) val;
			   break;
			case IDLIST :
			   relVal = (Relation) val;
			   break;
			default:  throw new InterpretError("type not implemented");
			
		 }
	  }
	  else
	  	Global.println("Warning: Stateinfo.java : setVal() received null val");
	 }
	 
   public Object getVal(int type) throws InterpretError
   {  Object ret;
	  switch (type)
		 {  case BOOLEAN :
			   ret = new Byte((byte) intVal);
			   break;
			case SHORT :
			   ret = new Short((short) intVal);
			   break;
			case INTEGER :
			   ret = new Integer(intVal);
			   break;
			case LONG :
			   ret = new Long(longVal);
			   break;
			case FLOAT :
			   ret = new Float(floatVal);
			   break;
			case DOUBLE :
			   ret = new Double(doubleVal);
			   break;
			case STRING :
			   ret = stringVal;
			   break;
			case IDLIST :
			   ret = relVal;
			   break;
			default:  throw new InterpretError("type not implemented");
		 }
		 return ret;
	  
	 }
	 
	 //for debugging
	 public void dump(int type) throws InterpretError
	 {
	 	switch (type)
		 {  case BOOLEAN :
			   System.out.println((intVal == 1)? "true" : "false");
			   break;
			case SHORT :
			   System.out.println((short) intVal);
			   break;
			case INTEGER :
			   System.out.println(intVal);
			   break;
			case LONG :
			   System.out.println(longVal);
			   break;
			case FLOAT :
			   System.out.println(floatVal);
			   break;
			case DOUBLE :
			   System.out.println(doubleVal);
			   break;
			case STRING :
			   System.out.println(stringVal);
			   break;
			case IDLIST :
			   System.out.println(relVal.name);
			   break;
			default:  throw new InterpretError("type not implemented");
		 }
		}
	public void dump() {} //Yi Zheng May 14, 2002, to implement the abstract dump method

}	 
